import { getLocalStorageObject } from "../initializer";

export const MAIN_MENU_KEY = "mainMenu";
export const FAVORITE_KEY = "FavoriteItems";
export const CREDENTIALS = "credentials"
export const IS_RTL = "isRTL"


export const getMainMenu = async (currentUser) => {
  if (!currentUser) return null;
  const mainMenu =await getLocalStorageObject().getItem(`${MAIN_MENU_KEY}.${currentUser.username}`);
  console.log("getmainMenuuuuuuuuuu",mainMenu)
  if (!mainMenu) return [];
  return JSON.parse(mainMenu);
};

export const setMainMenu =async (currentUser, mainMenu) => {
  console.log("setmainMenuuuuuuuuuu",mainMenu)

  if (!currentUser) return;
  await getLocalStorageObject().setItem(`${MAIN_MENU_KEY}.${currentUser.username}`, JSON.stringify(mainMenu));
};

export const getFavoriteItems =async (currentUser) => {
  if (!currentUser) return null;
  const favorite =await getLocalStorageObject().getItem(`${FAVORITE_KEY}.${currentUser.username}`);
  if (!favorite) return [];
  return JSON.parse(favorite);
};

export const setFavoriteItems =async (currentUser, favorite) => {
  if (!currentUser) return;
  if (Array.isArray(favorite)) {
    await getLocalStorageObject().setItem(`${FAVORITE_KEY}.${currentUser.username}`, JSON.stringify(favorite));
  }
};
export const setCurrentUserCredentials = async (userName, password) => {
  await getLocalStorageObject().setItem(CREDENTIALS, JSON.stringify({ userName, password }));
}
export const getCurrentUserCredentials = async () => {
  const credentials = JSON.parse(await getLocalStorageObject().getItem(CREDENTIALS));
  return credentials
}
export const setisRTL = async (isRTL) => {
  await getLocalStorageObject().setItem(IS_RTL, JSON.stringify(isRTL));
}
export const getisRTL = async () => {
  return getLocalStorageObject().getItem(IS_RTL);
  // return JSON.parse(isRTL)
}